# Generated by Hype
require '/home/harak/git/saclab/intro-htn/HyperTensioN/Hypertension'

module Basic
  include Hypertension
  extend self

  #-----------------------------------------------
  # Domain
  #-----------------------------------------------

  @domain = {
    # Operators
    :pickup => true,
    :drop => true,
    # Methods
    :swap => [
      :swap_case_0,
      :swap_case_1
    ]
  }

  #-----------------------------------------------
  # Operators
  #-----------------------------------------------

  def pickup(_a)
    return if @state[HAVE].include?(_a)
    @state = @state.dup
    (@state[HAVE] = @state[HAVE].dup).unshift(_a)
    true
  end

  def drop(_a)
    return unless @state[HAVE].include?(_a)
    @state = @state.dup
    (@state[HAVE] = @state[HAVE].dup).delete(_a)
    true
  end

  #-----------------------------------------------
  # Methods
  #-----------------------------------------------

  def swap_case_0(_x, _y)
    return unless @state[HAVE].include?(_x)
    return if @state[HAVE].include?(_y)
    yield [
      [:drop, _x],
      [:pickup, _y]
    ]
  end

  def swap_case_1(_x, _y)
    return unless @state[HAVE].include?(_y)
    return if @state[HAVE].include?(_x)
    yield [
      [:drop, _y],
      [:pickup, _x]
    ]
  end
end